//miragrid.js
//automatically generate objects to simulate live.grid in a mira frame

inlets=1;
outlets=2;
var norows=8;
var newrows=8;
var nocolumns=0;
var first=true;

// Maxobj variables for scripting
var toggle = new Array(512);
var sel1 = new Array(512);
var trign = new Array(512);
var pak=new Array(32);
var gate=new Array(32);
var tabs=new Array(32);
var mult=new Array(32);
var add=new Array(32);
var thegrid;
var messagerows;
var messagecols;
var miraframe;

//columns -- for each column
function columns(val)
{
	if(arguments.length) 
	{
		a=arguments[0];
		// safety check for number of sliders
		if(a<0) a = 0; // too few sliders, set to 0
		if(a>32) a = 32; // too many sliders, set to 32
		
			// out with the old...
			
		remove();

		// ...in with the new
		nocolumns = a; // update our global number of sliders to the new value
		if(first) 
		{
			thegrid = this.patcher.newdefault(300, 500, "live.grid", a,newrows,"@presentation", 1,"@presentation_rect",300,500); // make the grid
			ourself = this.box; // assign a Maxobj to our js object
            this.patcher.connect(ourself, 0, thegrid,0); // connect the funnel to us
			this.patcher.connect(ourself, 1, thegrid,0);
		}
			
		first=false;
		for(j=0;j<a;j++)
		{
			pak[j]=this.patcher.newdefault(850,j*100+50,"pak",j+1,1,1);
			gate[j]=this.patcher.newdefault(950,j*100+50,"gate",newrows);
			tabs[j]=this.patcher.newdefault(300+(j*15),10+(newrows*15),"live.tab","@patching_rect", 300+(j*15),50+(newrows*15), 15,45,"@_parameter_range",">","X","<", "@presentation", 1,"@presentation_rect", 10,20);
			mult[j]=this.patcher.newdefault(300+(j*15),280+(newrows*15),"*",-1);
			add[j]=this.patcher.newdefault(300+(j*15),300+(newrows*15),"+",+1);
			this.patcher.connect(tabs[j],0,mult[j],0)
			this.patcher.connect(mult[j],0,add[j],0)
			this.patcher.connect(add[j],0,pak[j],2)
			this.patcher.connect(pak[j],0,thegrid,0)
			for(k=0;k<newrows;k++) // create the new ctlin and uslider objects, connect them to one another and to the funnel
			{
				toggle[j+(k*newrows)] = this.patcher.newdefault(300+(j*15), 50+(k*15), "live.toggle", k+1,"@presentation", 1,"@presentation_rect", 300+(j*15), 50+(k*15),15,15);
				sel1[j+(k*newrows)] = this.patcher.newdefault(850+(k*100), j*100+0, "sel", 1);
				trign[j+(k*newrows)] = this.patcher.newdefault(850+(k*100), j*100+20, "t", newrows-k, 0);
				this.patcher.connect(toggle[j+(k*newrows)], 0, sel1[j+(k*newrows)], 0);
				this.patcher.connect(sel1[j+(k*newrows)], 0, trign[j+(k*newrows)], 0);
				this.patcher.connect(trign[j+(k*newrows)], 0, pak[j], 1);
				this.patcher.connect(trign[j+(k*newrows)], 0, gate[j], 0);
				this.patcher.connect(trign[j+(k*newrows)], 1, gate[j], 1);
				this.patcher.connect(gate[j],newrows-k-1,toggle[j+(k*newrows)], 0);
			} 
	
	
			
		
		}
		outlet(0,"columns",nocolumns);
		outlet(1,"rows",newrows);
		miraframe=this.patcher.newdefault(240,10,"mira.frame",1,"@presentation", 1,"@presentation_rect",240,10,400,300);
	}
}

	
//function rows
function rows(val)
{
	if(arguments.length) 
	{
	remove();
	newrows=val;
	columns(nocolumns);
	norows=newrows;
	outlet(0,"rows",norows);
	}
}


//function clear
function clear()
{
	
	this.patcher.remove(thegrid);
	first=true;
	remove();
}

//function removeelements
function remove()
{
	
	for(j=0;j<16;j++)
		{
		for(i=0;i<32;i++) 
			{
			this.patcher.remove(toggle[j+(i*norows)]);
			this.patcher.remove(sel1[j+(i*norows)]);
			this.patcher.remove(trign[j+(i*norows)]);
			}
		 this.patcher.remove(pak[j]);
		this.patcher.remove(gate[j]);
		this.patcher.remove(tabs[j]);
		this.patcher.remove(mult[j]);
		this.patcher.remove(add[j]);
		this.patcher.remove(miraframe);
		}
}
